=== debian/changelog ===
opencv (4.5.1+dfsg-5~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * d/control: Add libdc1394-22-dev as alternative to libdc1394-dev.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 05 Jul 2021 18:51:16 -0700

opencv (4.5.1+dfsg-5) unstable; urgency=medium

  * Team upload.
  * Drop depends between library packages (Closes: #979809)
  * Drop ${java:Depends}/${java:Recommends} (undefined)
  * Update libgdcm-dev arch list (Closes: #987621)

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 16 Jun 2021 14:09:47 +0200

opencv (4.5.1+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Revert "Fix debian-rules-sets-DEB_BUILD_OPTIONS"
  * Add more Breaks for old ros-vision-opencv packages

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 31 Dec 2020 12:01:15 +0100

opencv (4.5.1+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Add Breaks for packages encoding old library names
  * Fix debian-rules-sets-DEB_BUILD_OPTIONS
  * Remove wrong lintian-overrides
  * bump policy and debhelper versions
  * Add MA hints

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 30 Dec 2020 17:24:43 +0100

opencv (4.5.1+dfsg-2) unstable; urgency=medium

  [ Mo Zhou ]
  * Bump B-D from VTK-7 to VTK-9.
  * Add runtime Deps libcharls2 for python3-opencv. (Closes: #978452)

  [ Pino Toscano ]
  * Fix FTBFS on architectures without java. (Closes: #978028)

 -- Mo Zhou <lumin@debian.org>  Tue, 29 Dec 2020 14:45:26 +0800

opencv (4.5.1+dfsg-1) unstable; urgency=medium

  * New upstream version 4.5.1+dfsg
  * Refresh installation paths for upstream 4.5.1 release.
  * Mark libopencv*-{java,jni} as Multi-Arch: no. (Closes: #969957)
  * Correct bogus build dependencies on gdcm packages (Closes: #977991)
  * Demote libopencv*-java to Recommends for libopencv-dev. (Closes: #969960)

 -- Mo Zhou <lumin@debian.org>  Thu, 24 Dec 2020 14:03:53 +0800

opencv (4.5.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Tue, 22 Dec 2020 14:47:25 +0800

opencv (4.5.0+dfsg-1) experimental; urgency=medium

  * New upstream version 4.5.0+dfsg (Closes: #959526)
  * Bump VERSION from 4.4.0->4.5.0 for all control files.
  * Install the newly added "mcc" module to libopencv-contrib{4.5,-dev}.
  * d/copyright: Global license has been changed into Apache-2.0
  * Deprecate libavresample in favor of libswresample. (Closes: #971330)
  * Replace B-D libdc1394-22-dev with libdc1394-dev. (Closes: #970842)
  * Bump VTK dep from libvtk6-dev to libvtk7-dev.
  * Refresh d/copyright for opencv 4.5.0.
  * Update lintian overrides.

 -- Mo Zhou <lumin@debian.org>  Wed, 02 Dec 2020 17:01:26 +0800

opencv (4.4.0+dfsg2-1) experimental; urgency=medium

  * New upstream version 4.4.0+dfsg2 (Closes: #959526)
  * Refresh existing patches.
  * Bump VERSION from 4.3->4.4 for all control files.
  * rules: Add a comment on WITH_QT=OFF.
  * rules: Toggle cmake option -DWITH_GPHOTO2=ON. (Closes: #963143)
  * d/copyright: Filter out one more lena image.

 -- Mo Zhou <lumin@debian.org>  Sat, 05 Sep 2020 14:08:36 +0800

opencv (4.3.0+dfsg-1) experimental; urgency=medium

  * New upstream version 4.3.0+dfsg
  * Bump SOVER from 4.2 to 4.3 for control files.

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Apr 2020 14:51:13 +0800
