=== debian/tests/control ===
Test-Command: python3 debian/tests/test.py
Depends: python3, python3-numpy, @
Restrictions: allow-stderr
